//
//  GetURLScriptCommand.m
//  LilyRunner
//
//  Created by Toshi Nagata on 09/02/08.
//  Copyright 2009 Toshi Nagata. All rights reserved.
//
/*
 Copyright (c) 2009 Toshi Nagata. All rights reserved.
 
 Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
 
 1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
 
 THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#import "GetURLScriptCommand.h"
#import "MyAppController.h"

@implementation GetURLScriptCommand

- (id)performDefaultImplementation
{
	int line, ch;
    NSString *urlString = [self directParameter];
	const char *str = [urlString UTF8String];
	char *buf = strdup(str);  /*  A convenient way to allocate sufficient memory  */
	if (sscanf(str, "textedit://%[^:]:%d:%d", buf, &line, &ch) < 3) {
		NSRunAlertPanel(@"Error", @"Bad URL format", @"OK", nil, nil);
		free(buf);
		return nil;
	}
	[[NSApp delegate] openEditorWithFile: [NSString stringWithUTF8String: buf] line: line column: ch];
	free(buf);
	return nil;
}

@end
